package jp.co.cybec.laxide.model.base;

import jp.co.cybec.laxide.util.LetsAjaxUtil;

import org.eclipse.ui.views.properties.ComboBoxPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;
import org.jdom.Element;

/**
 * ラジオボタンのモデルクラス
 * 
 * @author tokumaru
 */
public class LetsAjaxRadioButtonModel extends BaseModel {
	private String name = "radio button";

	public static final String P_NAME = "_name";

	private String value;

	public static final String P_VALUE = "_value";

	private String componentWidth = "80";

	private String componentHeight = "20";

	public static final String P_EVENT = "_event";

	public static final String P_DATASOURCE_ID = "_dataSourceId";

	private String dataSourceId = "dataSourceId";

	private int eventId = 1;

	private String events[] = {"", "onClick", "onDblClick ", "onMouseDown",
			"onKeyDown", "onKeyPress", "onKeyUp", "onMouseDown", "onMouseUp",
			"onMouseOver", "onMouseOut", "onMouseMove", "onChange", "onSelect" };

	/* (non-Javadoc)
	 * @see jp.co.cybec.laxide.model.base.BaseModel#getBodyComponentXml()
	 */
	@Override
	public String getBodyComponentXml() {
		String html = "";
		html = html + getNameForXml();
		html = html + getValueForXml();
		html = html + getComponetWidthForXml();
		html = html + getComponetHeightForXml();
		html = html + getCssClassNameForXml();
		html = html + getEventForXml() + getDataSourceIdForXml();
		return html;
	}

	/* (non-Javadoc)
	 * @see jp.co.cybec.laxide.model.base.AbstractModel#setAttribute(org.jdom.Element)
	 */
	@Override
	public void setAttribute(Element element) {
		super.setAttribute(element);
		super.setType(LetsAjaxLayoutConstant.LETSAJAX_BODY_RADIOBUTTON);

		this
				.setName(element
						.getAttributeValue(LetsAjaxLayoutConstant.LETSAJAX_ATTRIBUTE_NAME));
		this
				.setValue(element
						.getAttributeValue(LetsAjaxLayoutConstant.LETSAJAX_ATTRIBUTE_VALUE));
		this.componentWidth = element
				.getAttributeValue(LetsAjaxLayoutConstant.LETSAJAX_ATTRIBUTE_COMPONENT_WIDTH);

		this.componentHeight = element
				.getAttributeValue(LetsAjaxLayoutConstant.LETSAJAX_ATTRIBUTE_COMPONENT_HEIGHT);
		String event = element
				.getAttributeValue(LetsAjaxLayoutConstant.LETSAJAX_ATTRIBUTE_EVENT);
		String dataSourceId = element
				.getAttributeValue(LetsAjaxLayoutConstant.LETSAJAX_ATTRIBUTE_DATASOURCEID);
		
		String cssClass = element
				.getAttributeValue(LetsAjaxLayoutConstant.LETSAJAX_ATTRIBUTE_CLASSNAME);
		
		super.setCssClassName(cssClass);
		setDataSourceId(dataSourceId);
		setEventId(1);
		for (int i = 0; i < events.length; i++) {
			if (event != null && event.equals(events[i])) {
				setEventId(i + 1);
				break;
			}
		}
	}

	/**
	 * ラジオボタン名を設定します
	 * 
	 * @param value ラジオボタン名
	 */
	public void setName(String value) {
		this.name = LetsAjaxUtil.checkNull(value);
		firePropertyChange(P_NAME, null, this.name);
	}

	/**
	 * ラジオボタン名を返します
	 * 
	 * @return ラジオボタン名
	 */
	public String getName() {
		return this.name;
	}

	/**
	 * .laxファイルに設定するためのラジオボタン名を返します
	 * 
	 * @return .laxファイルに設定するためのラジオボタン名 
	 */
	private String getNameForXml() {
		if (this.name == null || (this.name != null && this.name.equals(""))) {
			return "";
		}
		return " name=\"" + this.name + "\" ";
	}

	/**
	 * ラジオボタンのValue値を設定します
	 * 
	 * @param value ラジオボタンのValue値
	 */
	public void setValue(String value) {
		this.value = LetsAjaxUtil.checkNull(value);
		firePropertyChange(P_VALUE, null, this.value);
	}

	/**
	 * ラジオボタンのValue値を返します
	 * 
	 * @return ラジオボタンのValue値
	 */
	public String getValue() {
		return this.value;
	}

	/**
	 * .laxファイルに設定するためのValue値を返します
	 * 
	 * @return .laxファイルに設定するためのValue値
	 */
	private String getValueForXml() {
		if (this.value == null || (this.value != null && this.value.equals(""))) {
			return "";
		}
		return " value=\"" + this.value + "\" ";
	}

	/**
	 * 部品の幅を返します
	 * 
	 * @return 部品の幅
	 */
	public String getComponentWidth() {
		return this.componentWidth;
	}

	/**
	 * 部品の幅を設定します
	 * 
	 * @param width 部品の幅
	 */
	public void setComponentWidth(String width) {
		this.componentWidth = width;
	}

	/**
	 * .laxファイルに設定するための部品の幅を返します
	 * 
	 * @return .laxファイルに設定するための部品の幅
	 */
	private String getComponetWidthForXml() {
		if (componentWidth == null
				|| (componentWidth != null && componentWidth.equals(""))) {
			return " componentWidth=\""
					+ Integer.toString(this.value.length() * 5) + "\"";
		}
		return " componentWidth=\"" + this.componentWidth + "\" ";
	}

	/**
	 * 部品の高さを返します
	 * 
	 * @return 部品の高さ
	 */
	public String getComponetHeight() {
		return this.componentHeight;
	}

	/**
	 * 部品の高さを設定します
	 * 
	 * @param componentHeight 部品の高さ
	 */
	public void setComponentHeight(String componentHeight) {
		this.componentHeight = componentHeight;
	}

	/**
	 * .laxファイルに設定するための部品の高さを返します
	 * 
	 * @return .laxファイルに設定するための部品の高さ
	 */
	private String getComponetHeightForXml() {
		if (componentHeight == null
				|| (componentHeight != null && componentHeight.equals(""))) {
			return " componentHeight=\"20\"";
		}
		return " componentHeight=\"" + this.componentHeight + "\" ";
	}

	/* (non-Javadoc)
	 * @see jp.co.cybec.laxide.model.base.AbstractModel#getPropertyDescriptors()
	 */
	public IPropertyDescriptor[] getPropertyDescriptors() {
		IPropertyDescriptor[] descriptors = new IPropertyDescriptor[] {
				new TextPropertyDescriptor(P_ID, "ID"),
				new TextPropertyDescriptor(P_NAME, "名称"),
				new TextPropertyDescriptor(P_VALUE, "値"),
				new TextPropertyDescriptor(P_CLASS_NAME, "CSSクラス名"),
				new ComboBoxPropertyDescriptor(P_EVENT, "イベント", events),
				new TextPropertyDescriptor(P_DATASOURCE_ID, "DATASOURCEID") };
		return descriptors;
	}

	/* (non-Javadoc)
	 * @see jp.co.cybec.laxide.model.base.AbstractModel#getPropertyValue(java.lang.Object)
	 */
	public Object getPropertyValue(Object id) {
		if (id.equals(super.P_ID)) {
			return super.id;
		} else if (id.equals(P_NAME)) {
			return name;
		} else if (id.equals(P_VALUE)) {
			return value;
		} else if (id.equals(P_EVENT)) {
			return new Integer(this.eventId - 1);
		} else if (id.equals(P_DATASOURCE_ID)) {
			return dataSourceId;
		} else if (id.equals(P_CLASS_NAME)) {
			return getCssClassName();
		}
		
		return null;
	}

	/* (non-Javadoc)
	 * @see jp.co.cybec.laxide.model.base.AbstractModel#isPropertySet(java.lang.Object)
	 */
	public boolean isPropertySet(Object id) {
		if (id.equals(P_NAME) || id.equals(P_VALUE) || id.equals(P_EVENT)
				|| id.equals(P_DATASOURCE_ID) || id.equals(P_CLASS_NAME)) {
			return true;
		} else {
			return false;
		}
	}

	/* (non-Javadoc)
	 * @see jp.co.cybec.laxide.model.base.AbstractModel#setPropertyValue(java.lang.Object, java.lang.Object)
	 */
	public void setPropertyValue(Object id, Object value) {
		if (id.equals(P_NAME)) {
			setName((String) value);
		} else if (id.equals(P_VALUE)) {
			setValue((String) value);
		} else if (id.equals(P_EVENT)) {
			setEventId(((Integer) value).intValue() + 1);
		} else if (id.equals(P_DATASOURCE_ID)) {
			setDataSourceId((String) value);
		} else if (id.equals(P_CLASS_NAME)) {
			super.setCssClassName((String) value);
		}
	}

	/**
	 * データソースIDを返します
	 * 
	 * @return dataSourceId データソースID
	 */
	public String getDataSourceId() {
		return dataSourceId;
	}

	/**
	 * データソースIDを設定します
	 * 
	 * @param dataSourceId データソースID
	 */
	public void setDataSourceId(String dataSourceId) {
		this.dataSourceId = LetsAjaxUtil.checkNull(dataSourceId);
		firePropertyChange(P_DATASOURCE_ID, null, dataSourceId);
	}

	/**
	 * .laxファイルに設定するためのデータソースIDを返します
	 * 
	 * @return .laxファイルに設定するためのデータソースID 
	 */
	private String getDataSourceIdForXml() {
		if (this.dataSourceId == null
				|| (this.dataSourceId != null && this.dataSourceId.equals(""))) {
			return "";
		}
		return " dataSourceId=\"" + this.dataSourceId + "\"";
	}

	/**
	 * イベントIDを返します
	 * 
	 * @return event イベントID
	 */
	public int getEventId() {
		return eventId;
	}

	/**
	 * イベントIDを設定します
	 * 
	 * @param event イベントID
	 */
	public void setEventId(Integer eventId) {
		this.eventId = LetsAjaxUtil.checkNull(eventId);
		firePropertyChange(P_EVENT, null, this.eventId);
	}

	/**
	 * ,laxに設定するためのイベントIDを返します
	 * 
	 * @return イベントID
	 */
	private String getEventForXml() {
		return " event=\"" + events[eventId - 1] + "\"";
	}
}
